package com.winhc.bigdata.spark.utils

import java.util.Date

import org.apache.spark.sql.SparkSession

import scala.annotation.meta.getter

/**
 * π
 * cid转换
 */

case class CompanyForCidUtils(s: SparkSession, space: String, sourceTable: String, cols: Seq[String]) extends LoggingUtils {
  @(transient@getter) val spark: SparkSession = s

  def calc(): Unit = {
    println(s"${this.getClass.getSimpleName} calc start! " + new Date().toString)

    val odsTable = s"${space}.$sourceTable"
    val adsTable = s"${space}.ads_${sourceTable.substring(4)}"
    val companyMapping = s"${space}.company_map"
    val ds = BaseUtil.getPartion(odsTable, spark)
    //table字段
    val columns: Seq[String] = spark.table(odsTable).schema.map(_.name).filter(!_.equals("ds"))
    val disCol = cols

    //替换字段
    sql(
      s"""
         |INSERT OVERWRITE TABLE ${adsTable} PARTITION(ds=${ds})
         |SELECT  rowkey,new_cid,${columns.mkString(",")}
         |FROM    (
         |        SELECT
         |                *
         |                ,ROW_NUMBER() OVER (PARTITION BY ${disCol.mkString(",")} ORDER BY id DESC ) num
         |                ,CONCAT_WS('_',new_cid,id) AS rowkey
         |        FROM    (
         |                SELECT
         |                        a.*
         |                        ,coalesce(b.new_cid,a.cid) AS new_cid
         |                FROM    $odsTable a
         |                LEFT JOIN $companyMapping b
         |                ON      a.cid = b.cid
         |                WHERE   a.ds = $ds AND a.cid IS NOT NULL
         |                ) c
         |        ) d
         |WHERE   num =1
         |""".stripMargin)
//      .createOrReplaceTempView(s"t2")

//    sql(s"select rowkey,new_cid,${columns.mkString(",")} from t2").show(10)

    //写表
//    sql(s"insert into table ${adsTable} partition (ds=${ds}) select rowkey,new_cid,${columns.mkString(",")} from t2")

    println(s"${this.getClass.getSimpleName} calc end! " + new Date().toString)
  }
}